// Clase vector

public class Vector
{
  private double datos[];

  // Constructor

  public Vector (double datos[])
  {
    this.datos = datos;
  }

  // Salida estndar

  public String toString ()
  {
    int    i;
    String resultado = "{"+datos[0];

    for (i=1; i<datos.length; i++)
        resultado += ","+datos[i];

    resultado += "}";

    return resultado;
  }

  // Ejercicio 2: Eliminacin de datos repetidos
  // -------------------------------------------

  // Alternativa A: Detectar datos repetidos

  public void eliminarRepetidosA()
  {
    int     i,j;
    int     distintos;
    boolean repetido[];
    double  resultado[];
    
    // Vector auxiliar para controlar los datos repetidos

    repetido = new boolean[datos.length];

    for (i=0; i<datos.length; i++)
        repetido[i] = false;

    for (i=0; i<datos.length; i++)
        for (j=i+1; j<datos.length; j++)
            if (datos[j]==datos[i])
               repetido[j] = true;

    // Contar datos distintos

    distintos = 0;

    for (i=0; i<datos.length; i++)
        if (!repetido[i])
           distintos++;

     // Resultado

     resultado = new double[distintos];
     j = 0;

     for (i=0; i<datos.length; i++) {
         if (!repetido[i]) {
            resultado[j] = datos[i];
            j++;
         }
     }

     // Actualizar estado del objeto

     datos = resultado;
  }


  // Alternativa B: Contar repeticiones

  public void eliminarRepetidosB()
  {
    int     i,j;
    int     distintos;
    int     repeticiones[];
    double  resultado[];
    
    // Vector auxiliar de repeticiones

    repeticiones = new int[datos.length];

    for (i=0; i<datos.length; i++)
        repeticiones[i] = 0;

    for (i=0; i<datos.length; i++)
        for (j=i+1; j<datos.length; j++)
            if (datos[j]==datos[i])
               repeticiones[j]++;

    // Contar datos distintos

    distintos = 0;

    for (i=0; i<datos.length; i++)
        if (repeticiones[i]==0)
           distintos++;

     // Resultado

     resultado = new double[distintos];
     j = 0;

     for (i=0; i<datos.length; i++) {
         if (repeticiones[i]==0) {
            resultado[j] = datos[i];
            j++;
         }
     }

     // Actualizar estado del objeto

     datos = resultado;
  }


  // Alternativa C: Sin vector auxiliar

  public void eliminarRepetidosC()
  {
    int     i,j,n;
    int     distintos;
    boolean repetido;
    double  resultado[];

    // Contar datos no repetidos

    distintos = 0;
    
    for (i=0; i<datos.length; i++) {

        repetido = false;

        for (j=i-1; j>=0; j--)
            if (datos[j]==datos[i])
               repetido = true;

        if (!repetido)
           distintos++;
    }

    // Generar vector nuevo sin repetidos

    resultado = new double[distintos];
    n = 0;

    for (i=0; i<datos.length; i++) {

        repetido = false;

        for (j=i-1; j>=0; j--)
             if (datos[j]==datos[i])
               repetido = true;
    
        if (!repetido) {
            resultado[n] = datos[i];
            n++;
        }
    }

    
    // Actualizar estado del objeto

    datos = resultado;
  }


  // Alternativa D: Con un vector auxiliar para datos

  public void eliminarRepetidosD()
  {
    int     i,j,n;
    int     distintos;
    boolean repetido;
    double  noRepetidos[];
    double  resultado[];

    // Vector auxiliar

    noRepetidos = new double[datos.length];  

    // Obtener datos no repetidos

    distintos = 0;
    
    for (i=0; i<datos.length; i++) {

        repetido = false;

        for (j=0; j<i; j++)
            if (datos[j]==datos[i])
               repetido = true;

        if (!repetido) {
           noRepetidos[distintos] = datos[i];
           distintos++;
        }
    }

    // Vector resultado

    resultado = new double[distintos];

    for (i=0; i<distintos; i++) {
        resultado[i] = noRepetidos[i];
    }

    
    // Actualizar estado del objeto

    datos = resultado;
  }


  // Ejercicio 3: Ordenar por valor absoluto
  // ---------------------------------------
  // Por seleccin

  public void ordenarValorAbsoluto ()
  {
    int i,j;
    int pos_max;
    double aux;

    for (i=0; i<datos.length-1; i++) {

        pos_max = i;

        for (j=i+1; j<datos.length; j++)
            if ( Math.abs(datos[j])>Math.abs(datos[pos_max]) )
               pos_max = j;

        aux = datos[i];
        datos[i] = datos[pos_max];
        datos[pos_max] = aux;
    }
  }

  // Ejercicio 4: Recursividad
  // -------------------------

  // Algoritmo recursivo

  void in (int j, int k)
  {
    double aux;

    if (j<k) {
       in (j+1, k-1);
       aux = datos[j];
       datos[j] = datos[k];
       datos[k] = aux;
    }
  }

  // Algoritmo iterativo

  void inIterativo (int j, int k)
  {
    double aux;

    while (j<k) {
          aux = datos[j];
          datos[j] = datos[k];
          datos[k] = aux;
          j++;
          k--;
    }
  }

  // Implementacin alternativa

  void inAlternativo (int j, int k)
  { 
    int    i;
    double aux;

    for (i=0; i<=(k-j)/2; i++) {
          aux = datos[j+i];
          datos[j+i] = datos[k-i];
          datos[k-i] = aux;
    }
  }


  // Test
  // ----

  public static void main (String args[])
  {
     Vector vector;

    // Ejercicio 2

     System.out.println("EJERCICIO 2");
     vector = new Vector(new double[]{1,3,2,2,1,3});
     System.out.println(vector);

     vector = new Vector(new double[]{1,3,2,2,1,3});
     vector.eliminarRepetidosA();
     System.out.println("Alternativa A ==> "+vector);
     
     vector = new Vector(new double[]{1,3,2,2,1,3});
     vector.eliminarRepetidosB();
     System.out.println("Alternativa B ==> "+vector);

     vector = new Vector(new double[]{1,3,2,2,1,3});
     vector.eliminarRepetidosC();
     System.out.println("Alternativa C ==> "+vector);

     vector = new Vector(new double[]{1,3,2,2,1,3});
     vector.eliminarRepetidosD();
     System.out.println("Alternativa D ==> "+vector);

    // Ejercicio 3

     System.out.println("EJERCICIO 3");   
     vector = new Vector(new double[]{0,3,-4,2,-1});
     System.out.println(vector);

     vector = new Vector(new double[]{0,3,-4,2,-1});
     vector.ordenarValorAbsoluto();
     System.out.println("Por seleccin ==> "+vector);

    // Ejercicio 4

     System.out.println("EJERCICIO 4");
     vector = new Vector(new double[]{1,3,5,7,9,11,13,15});
     System.out.println(vector);

     vector = new Vector(new double[]{1,3,5,7,9,11,13,15});
     vector.in(2,6);
     System.out.println("Recursivo   ==> "+vector);

     vector = new Vector(new double[]{1,3,5,7,9,11,13,15});
     vector.inIterativo(2,6);
     System.out.println("Iterativo   ==> "+vector);

     vector = new Vector(new double[]{1,3,5,7,9,11,13,15});
     vector.inAlternativo(2,6);
     System.out.println("Alternativo ==> "+vector);  
  }

}